//+------------------------------------------------------------------+
//|                                                Doda-Donchian.mq4 |
//|                             Copyright  2010, Gopal Krishan Doda |
//|                                        http://www.DodaCharts.com |
//+------------------------------------------------------------------+


#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  Red
#property indicator_style1  2



extern int    ChannelPeriod    = 28; // from 28 to 20
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = false;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsNotify     = true;
extern bool   alertsEmail      = true;
extern string soundFile        = "alert2.wav"; 

double UpperLine[];
double LowerLine[];
double MidLine[];
double trend[];


int init()
  {
   IndicatorBuffers(4);
   SetIndexBuffer(0,MidLine);    SetIndexLabel(0,"MidLine");
   SetIndexBuffer(1,LowerLine);
   SetIndexBuffer(2,UpperLine);
   SetIndexBuffer(3,trend);
   
   IndicatorShortName("DonchianChannel("+ChannelPeriod+")");
   return(0);
  }
  
  
//+------------------------------------------------------------------+
//| Price Channel                                                         |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit = MathMin(Bars-counted_bars,Bars-1);
            
   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--) 
   {
      UpperLine[i] = High[iHighest(NULL,0,MODE_HIGH,ChannelPeriod,i)];
      LowerLine[i] =  Low[iLowest(NULL, 0,MODE_LOW, ChannelPeriod, i)];
      MidLine[i]   =(UpperLine[i]+LowerLine[i])*0.5;

      trend[i] = trend[i+1];
      if(Close[i]>MidLine[i]) trend[i] = 1;
      if(Close[i]<MidLine[i]) trend[i] =-1;
         
   }
   
   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("Buy");
      else  doAlert("Sell");       
   }
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," DD ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," DD " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," DD "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}